<?php
class ControllerExtensionPaymentipay88OnlineBanking extends Controller
{
    public function index()
    {
		$this->load->language('extension/payment/ipay88OnlineBanking');
				
        $data['button_confirm'] = $this->language->get('button_confirm');
        $data['continue'] 		= $this->url->link('checkout/success');	
		
		//ACTION
		$data['action'] 					= $this->config->get('payment_ipay88OnlineBanking_action');
		
		//METHOD TITLE
		$data['title']						= $this->config->get('payment_ipay88OnlineBanking_method_title');
		
		//DESCRIPTION
		$data['ipay88_description'] 		= $this->config->get('payment_ipay88OnlineBanking_description');
			
		//MANDIRI CLICKPAY
		$data['ipay88_mandiri_clickpay']	= $this->config->get('payment_ipay88OnlineBanking_mandiri_clickpay');
		
		//MANDIRI CLICKPAY LOGO
		$data['ipay88_mandiri_clickpay_logo'] 	= '<img src="catalog/view/theme/default/image/ipay88_mandiri_clickpay_logo.png" alt="iPay88" title="iPay88" style="vertical-align:middle"/>';
		
		//CIMB CLICKS
		$data['ipay88_cimb_clicks'] 		= $this->config->get('payment_ipay88OnlineBanking_cimb_clicks');
		
		//CIMB CLICKS LOGO
		$data['ipay88_cimb_clicks_logo']	= '<img src="catalog/view/theme/default/image/ipay88_cimb_clicks_logo.png" alt="iPay88" title="iPay88" style="vertical-align:middle"/>';	
		
		//INTERNET BANKING MUAMALAT
		$data['ipay88_ib_muamalat'] 		= $this->config->get('payment_ipay88OnlineBanking_ib_muamalat');
		
		//INTERNET BANKING MUAMALAT LOGO
		$data['ipay88_ib_muamalat_logo']	= '<img src="catalog/view/theme/default/image/ipay88_ib_muamalat_logo.png" alt="iPay88" title="iPay88" style="vertical-align:middle"/>';	
		
		//DANAMON ONLINE BANKING
		$data['ipay88_danamon_ob'] 			= $this->config->get('payment_ipay88OnlineBanking_danamon_ob');
		
		//DANAMON ONLINE BANKING LOGO
		$data['ipay88_danamon_ob_logo']	= '<img src="catalog/view/theme/default/image/ipay88_danamon_ob_logo.png" alt="iPay88" title="iPay88" style="vertical-align:middle"/>';	
		
		//Load Model
		$this->load->model('checkout/order');
		
		$order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);
				
		//PRODUCT
		$products = $this->cart->getProducts();
        
		foreach ($products as $product) 
		{
            $data['prod_desc'][] = " ".$product['name']." x ".$product['quantity'].", ";
        }
				
		//HASH AMOUNT
		$total 			= $this->currency->format($order_info['total'], $order_info['currency_code'], $order_info['currency_value'], false);
		$orderAmount	= number_format($total, 2, ".", "");
	    $HashAmount 	= str_replace(".","",str_replace(",","",$orderAmount));	
		
		
		//DATE HIS
		date_default_timezone_set('Asia/Jakarta');	
			
				
		//SIGNATURE
		$MechantKey 	= $this->config->get('payment_ipay88OnlineBanking_merchant_key');
		$MerchantCode 	= $this->config->get('payment_ipay88OnlineBanking_merchant_code');
		$RefNo			= $this->session->data['order_id']; 
		$Amount			= $HashAmount; 
		$Currency		= $order_info['currency_code'];
		$ipaySignature 	= "";
		
		$encrypt		= sha1($MechantKey.$MerchantCode.$RefNo.$Amount.$Currency);		
		
		for ($i=0; $i<strlen($encrypt); $i=$i+2)
		{
			$ipaySignature .= chr(hexdec(substr($encrypt,$i,2)));
		}
     	
		$ipaySignature = base64_encode($ipaySignature);
		
		//iPay88 Params
		$data['MerchantCode'] 	= $MerchantCode;
		$data['RefNo'] 			= $RefNo;
		$data['Amount'] 		= $HashAmount;
		$data['Currency'] 		= $Currency;
		$data['ProdDesc'] 		= implode($data['prod_desc']);
		$data['UserName'] 		= $order_info['payment_firstname'] . ' ' . $order_info['payment_lastname'];
		$data['UserEmail'] 		= $order_info['email'];
		$data['UserContact'] 	= $order_info['telephone'];
		$data['Remark'] 		= "Transaction date".date('Y-m-d H:i:s');
		$data['Lang'] 			= "UTF-8";
		$data['Signature'] 		= $ipaySignature;
		$data['ipay88_action'] 	= $this->config->get('ipay88_action');
		$data['ResponseURL'] 	= $this->url->link('extension/payment/ipay88OnlineBanking/callback', '', 'SSL');
		$data['BackendURL'] 	= $this->url->link('extension/payment/ipay88OnlineBanking/backendcallback', '', 'SSL');
				
        return $this->load->view('extension/payment/ipay88OnlineBanking', $data);
    }
	    
    public function callback()
    {
		//-----Sepay
        $this->load->language('extension/payment/ipay88OnlineBanking');
        $this->document->setTitle($this->language->get('text_payment_title'));
     
        $data['column_left'] 	= $this->load->controller('common/column_left');
        $data['column_right'] 	= $this->load->controller('common/column_right');
        $data['content_top']	= $this->load->controller('common/content_top');
        $data['content_bottom'] = $this->load->controller('common/content_bottom');
        $data['footer'] 		= $this->load->controller('common/footer');
        $data['header'] 		= $this->load->controller('common/header');
		//-----End Sepay
		
	  	$this->load->model('checkout/order');
		
		//Message for redirect page	
		$this->model_checkout_order->addOrderHistory($this->session->data['order_id'], 1, "iPay88 payment window page is being / has been ACCESSED.");		
		
		//Get reference number response
		$RefNo = $_REQUEST['RefNo'];
												
		if (isset($_REQUEST['RefNo'])) 
		{
			//Get signature response
			$signature_response		= $_REQUEST['Signature'];
			
			//Generate signature
			$MechantKey_response 	= $this->config->get('payment_ipay88OnlineBanking_merchant_key');
			$MerchantCode_response 	= $this->config->get('payment_ipay88OnlineBanking_merchant_code');
			$PaymentId_response		= $_REQUEST['PaymentId'];
			$RefNo_response 		= trim(stripslashes($_REQUEST['RefNo']));
			$HashAmount_response 	= str_replace(array(',','.'), "", $_REQUEST['Amount']);
			$Currency_response 		= $_REQUEST['Currency'];
			$Status_response 		= $_REQUEST['Status'];
			
			$merchant_signature		= "";
		
			$merchant_encrypt		= sha1($MechantKey_response.$MerchantCode_response.$PaymentId_response.$RefNo_response.$HashAmount_response.$Currency_response.$Status_response);		
		
			for ($i=0; $i<strlen($merchant_encrypt); $i=$i+2)
			{	
				$merchant_signature .= chr(hexdec(substr($merchant_encrypt,$i,2)));
			}
     	
			$merchant_signature_check = base64_encode($merchant_signature);
			
			//Payment success and signature match
			if ($_REQUEST['Status']=="1" && $merchant_signature_check==$signature_response) 
			{			
				$this->model_checkout_order->addOrderHistory($RefNo, 2, "iPay88 Payment Completed. Transaction Reference Number: ".$_REQUEST['TransId'].".");
				
				$this->response->redirect($this->url->link('checkout/success', '', true));		
				//$this->response->redirect($this->url->link('checkout/success'));	
			}
		
			//Payment failed
			else
			{								
				$this->model_checkout_order->addOrderHistory($RefNo, 10, "iPay88 Payment Failed. Error Description: ".$_REQUEST['ErrDesc'].". Transaction Reference Number: ".$_REQUEST['TransId'].".");
			
				$data['checkout_link'] = $this->url->link('checkout/checkout', '', true);
           	 	$this->response->setOutput($this->load->view('extension/payment/ipay88OnlineBanking_failed', $data));
					
				//$this->response->redirect($this->url->link('checkout/failure'));
			}
				
		}
			
		else
		{
			$this->cart->clear();

			unset($this->session->data['shipping_method']);
			unset($this->session->data['shipping_methods']);
			unset($this->session->data['payment_method']);
			unset($this->session->data['payment_methods']);
			unset($this->session->data['guest']);
			unset($this->session->data['comment']);
			unset($this->session->data['order_id']);	
			unset($this->session->data['coupon']);
			unset($this->session->data['reward']);
			unset($this->session->data['voucher']);
			unset($this->session->data['vouchers']);	 
		
			$this->response->redirect($this->url->link('common/home'));
		}
    }
	
	public function backendcallback() 
	{
		//-----Sepay
        $this->load->language('extension/payment/ipay88OnlineBanking');
        $this->document->setTitle($this->language->get('text_payment_title'));
     
        $data['column_left'] 	= $this->load->controller('common/column_left');
        $data['column_right'] 	= $this->load->controller('common/column_right');
        $data['content_top']	= $this->load->controller('common/content_top');
        $data['content_bottom'] = $this->load->controller('common/content_bottom');
        $data['footer'] 		= $this->load->controller('common/footer');
        $data['header'] 		= $this->load->controller('common/header');
		//-----End Sepay
		
	  		
		//Get reference number response
		$RefNo = $_REQUEST['RefNo'];
				
		if (isset($_REQUEST['RefNo'])) 
		{
			//Get signature response
			$signature_response		= $_REQUEST['Signature'];
			
			//Generate signature
			$MechantKey_response 	= $this->config->get('payment_ipay88OnlineBanking_merchant_key');
			$MerchantCode_response 	= $this->config->get('payment_ipay88OnlineBanking_merchant_code');
			$PaymentId_response		= $_REQUEST['PaymentId'];
			$RefNo_response 		= trim(stripslashes($_REQUEST['RefNo']));
			$HashAmount_response 	= str_replace(array(',','.'), "", $_REQUEST['Amount']);
			$Currency_response 		= $_REQUEST['Currency'];
			$Status_response 		= $_REQUEST['Status'];
			
			$merchant_signature		= "";
		
			$merchant_encrypt		= sha1($MechantKey_response.$MerchantCode_response.$PaymentId_response.$RefNo_response.$HashAmount_response.$Currency_response.$Status_response);		
		
			for ($i=0; $i<strlen($merchant_encrypt); $i=$i+2)
			{	
				$merchant_signature .= chr(hexdec(substr($merchant_encrypt,$i,2)));
			}
     	
			$merchant_signature_check = base64_encode($merchant_signature);
			
			//Receive OK
			if ($_REQUEST['Status']=="1" && $merchant_signature_check==$signature_response) 
			{			
				$this->response->setOutput($this->load->view('extension/payment/ipay88OnlineBanking_backend', $data));
			}
		
			//Backend failed
			else
			{
				$this->response->setOutput($this->load->view('extension/payment/ipay88OnlineBanking_backend_failed', $data));
			}
				
		}
			
		else
		{
			$this->cart->clear();

			unset($this->session->data['shipping_method']);
			unset($this->session->data['shipping_methods']);
			unset($this->session->data['payment_method']);
			unset($this->session->data['payment_methods']);
			unset($this->session->data['guest']);
			unset($this->session->data['comment']);
			unset($this->session->data['order_id']);	
			unset($this->session->data['coupon']);
			unset($this->session->data['reward']);
			unset($this->session->data['voucher']);
			unset($this->session->data['vouchers']);	 
		
			$this->response->redirect($this->url->link('common/home'));
		}		
	}
    
}


